import es
import cmdlib
import services
import popuplib2

info = es.AddonInfo()
info.name = "Command menu"
info.basename = "command_menu"
info.description = "Lists usable console and say commands in a menu"
info.author = "GODJonez"
info.url = "http://addons.eventscripts.com/addons/view/command_menu/"

auth = services.use('auth').isUseridAuthorized

def load():
    cmdlib.registerSayCommand('!help', show_main_menu, 'Show command menu')

def unload():
    cmdlib.unregisterSayCommand('!help')

def get_suitable_commands(userid, commands):
    suitable = []
    for command in commands.itervalues():
        if command.auth_capability is None or auth(userid, command.auth_capability):
            suitable.append(command)
    suitable.sort(key=lambda item:item.name)
    return suitable

def show_main_menu(userid, args):
    main_menu.send(userid)

def main_menu_builder(userid, popup):
    suitable_say_commands = get_suitable_commands(userid, cmdlib.cmd_manager.say_commands)
    suitable_client_commands = get_suitable_commands(userid, cmdlib.cmd_manager.client_commands)
    popup.add(('Say commands', suitable_say_commands), 'Say commands (%d)'%len(suitable_say_commands), bool(suitable_say_commands))
    popup.add(('Console commands', suitable_client_commands), 'Console commands (%d)'%len(suitable_client_commands), bool(suitable_client_commands))

def execute(params):
    userid = params['userid']
    command = params['choice']
    command.callback(userid, [])
    return params['popup']

def main_menu_selection(params):
    title, suitable_commands = params['choice']
    teh_menu = popuplib2.PagedMenu()
    teh_menu.title = title
    for command in suitable_commands:
        teh_menu.add(command, command.name)
    teh_menu.menuselect = execute
    return teh_menu

main_menu = popuplib2.PersonalMenu(main_menu_builder)
main_menu.menuselect = main_menu_selection
main_menu.title = "Available commands for you"
